﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Windows.Forms;

namespace ETH_Display
{
    public partial class ETH_Display : Form
    {

        private Socket sockClinet = null;

        private UdpClient slave_recv;       //接收客户端
        private IPEndPoint remoteipe_recv;  //远程端口
        private IPEndPoint localipe_recv;   //本机端口
        private byte[] buffer_recv;

        private Thread ShowPic;
        private Thread thread_eth;
        private byte flag_eth;

        Image im;

        public static int imageWidth = 0;//图像数据(帧/行)长度(图像宽度)
        public static int imageHeight = 0;//多少个(图像高度)

        int Direction;//0:0°, 1:90°, 2:180°, 3:270°

        // 缓冲的容量为 1800 * 1024 个单位.
        private static ArrayBuffer<byte> ab = new ArrayBuffer<byte>(1800 * 1024);

        public string CmdPath = @"C:\Windows\System32\cmd.exe";
        public string cmd_firewall_off = "netsh advfirewall set currentprofile state off";
        public string cmd_firewall_on = "netsh advfirewall set currentprofile state on";

        public static ushort RGB565_MASK_RED = 0xF800;
        public static ushort RGB565_MASK_GREEN = 0x07E0;
        public static ushort RGB565_MASK_BLUE = 0x001F;

        int FPS;    //帧率

        //[DllImport("Ws2_32.dll", EntryPoint = "accept")]
        //public static extern ECANStatus ReadErrInfo(
        //    UInt32 DeviceType,
        //    UInt32 DeviceInd,
        //    UInt32 CANInd,
        //    out CAN_ERR_INFO ReadErrInfo);

        public ETH_Display()
        {
            InitializeComponent();
            comboBoxPiexl.SelectedIndex = 0;
            imageWidth = 1280;
            imageHeight = 480;

            buffer_recv = null;//1282 * 480 * 15
            //buffer_recv = new byte[1282 * 480 * 15];

            flag_eth = 0;
        }

        #region 菜单操作
        private void toolStripMenuExit_Click(object sender, EventArgs e)
        {
            System.Environment.Exit(0);
        }

        private void toolStripMenuAbout_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Version : 2.1\r\nDate : 2019-06-04    \r\n版权所有：武汉芯路恒科技有限公司");
        }

        private void toolStripMenuForum_Click(object sender, EventArgs e)
        {
            try
            {
                System.Diagnostics.Process.Start("http://www.corecourse.cn");
            }
            catch { }
        }

        private void toolStripMenuMall_Click(object sender, EventArgs e)
        {
            try
            {
                System.Diagnostics.Process.Start("https://xiaomeige.taobao.com");
            }
            catch { }
        }
        #endregion

        private bool IPCheck(string IP)
        {
            return Regex.IsMatch(IP, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }
        private bool CheckNum(string text)
        {
            return Regex.IsMatch(text, "^\\d+$");
        }
        private void ETH_Display_Load(object sender, EventArgs e)
        {
            pictureBox1.InitialImage = null;
            buttonConnect.Focus();
            FPS = 0;
        }

        private void firewall_operate(string cmd)
        {
            cmd = cmd.Trim().TrimEnd('&') + "&exit";
            using (Process p = new Process())
            {
                p.StartInfo.FileName = CmdPath;
                p.StartInfo.UseShellExecute = false;        //是否使用操作系统shell启动
                p.StartInfo.RedirectStandardInput = true;   //接受来自调用程序的输入信息
                p.StartInfo.RedirectStandardOutput = true;  //由调用程序获取输出信息
                p.StartInfo.RedirectStandardError = true;   //重定向标准错误输出
                p.StartInfo.CreateNoWindow = true;          //不显示程序窗口
                p.Start();//启动程序

                //向cmd窗口写入命令:关闭或开启防火墙
                p.StandardInput.WriteLine(cmd);
                p.StandardInput.AutoFlush = true;

                p.WaitForExit();//等待程序执行完退出进程
                p.Close();
            }
        }

        private void ETH_Display_FormClosing(object sender, FormClosingEventArgs e)
        {
            firewall_operate(cmd_firewall_on);
            if (slave_recv != null)
                slave_recv.Close();
            //try
            //{
            //    slave_recv.Close();
            //}
            //catch (Exception ex)
            //{ }

            System.Environment.Exit(0);
        }

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (IPCheck(textBoxRemoteIP.Text.Trim()) && IPCheck(textBoxLocalIP.Text.Trim()) &&
                CheckNum(textBoxRemotePort.Text.Trim()) && CheckNum(textBoxLocalPort.Text.Trim()))
            {
                if (buttonConnect.Text.Trim() == "连接")
                {
                    firewall_operate(cmd_firewall_off);
                    //关闭防火墙后开始建立
                    remoteipe_recv = new IPEndPoint(IPAddress.Parse(textBoxRemoteIP.Text.Trim()), Convert.ToInt32(textBoxRemotePort.Text.Trim()));
                    localipe_recv = new IPEndPoint(IPAddress.Parse(textBoxLocalIP.Text.Trim()), Convert.ToInt32(textBoxLocalPort.Text.Trim()));

                    flag_eth = 1;
                    try
                    {
                        //sockClinet = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                        //sockClinet.Bind(localipe_recv);
                        //sockClinet.Connect(remoteipe_recv);

                        slave_recv = new UdpClient(localipe_recv);//创建一个socket
                    }
                    catch (Exception ex)
                    {
                        //MessageBox.Show(ex.ToString());
                        firewall_operate(cmd_firewall_on);
                        return;
                    }
                    Enable_Edit_Aera(false);
                    timer1.Enabled = true;
                    timer1.Start();
                    buttonConnect.Text = "断开";

                    //ab.Clear();//每次启动之前清空缓冲区

                    //timer1.Start();

                    thread_eth = new Thread(new ThreadStart(EthReceive));//创建接收线程
                    thread_eth.Priority = ThreadPriority.Highest;
                    thread_eth.IsBackground = true;
                    thread_eth.Start();

                    ShowPic = new Thread(new ThreadStart(ShowPics));
                    ShowPic.Priority = ThreadPriority.Highest;
                    ShowPic.IsBackground = true;
                    ShowPic.Start();
                }
                else
                {
                    Enable_Edit_Aera(true);
                    //timer1.Stop();
                    buttonConnect.Text = "连接";
                    firewall_operate(cmd_firewall_on);

                    flag_eth = 0;
                    thread_eth.Abort();
                    ShowPic.Abort();

                    //sockClinet.Close();
                    slave_recv.Close();
                }
            }
            else
            {
                MessageBox.Show("请检查输入的IP地址和端口号是否正确", "提示");
            }
        }

        /// <summary>
        /// 将RGB数据转换成BMP图片
        /// </summary>
        /// <param name="rgbFrame">RGB 格式图像数据。</param>
        /// <param name="width">图像宽（单位：像素）。</param>
        /// <param name="height">图像高（单位：像素）。</param>
        /// <returns>返回转换好的BMP图片</returns>
        public static Image RGB2Image(byte[] rgbFrame, int width, int height)
        {
            // 写 BMP 图像文件。
            Image image;

            //int yu = width * 3 % 4;
            int bytePerLine = 0;
            //yu = yu != 0 ? 4 - yu : yu;
            //bytePerLine = width * 3 + yu;
            bytePerLine = width * 2;

            using (MemoryStream ms = new MemoryStream(bytePerLine * height + 54 + 12))
            {
                //一、bmp文件头 14字节
                // 0-1 'BM'
                ms.WriteByte(0x42);//B
                ms.WriteByte(0x4D);//M
                // 2-5 图片大小（包含跟中信息）
                byte[] tmp_byte0 = BitConverter.GetBytes(bytePerLine * height + 54 + 12);//文件大小 width * height * 3 * 8;//54=14+40
                ms.WriteByte(tmp_byte0[0]);
                ms.WriteByte(tmp_byte0[1]);
                ms.WriteByte(tmp_byte0[2]);
                ms.WriteByte(tmp_byte0[3]);
                // 6-9 保留段，为0
                ms.WriteByte(0x00);//0   4字节保留，必须设置为0；
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                // A-D 从文件头到位图数据之间的字节的偏移量
                ms.WriteByte(0x42);//0  4字节的偏移,(十进制 54)表示从文件头到位图数据的偏移(这里没有用调色板)
                ms.WriteByte(0x00);//0  
                ms.WriteByte(0x00);//0  
                ms.WriteByte(0x00);//0  

                //二、位图信息 40 字节
                //0E-11 位图信息头的大小为40个字节
                ms.WriteByte(0x28);//0  信息头的大小 4 字节  (十进制 40)
                ms.WriteByte(0x00);//0 
                ms.WriteByte(0x00);//0 
                ms.WriteByte(0x00);//0 
                //12-15 图像宽度，单位像素
                byte[] tmp_byte1 = BitConverter.GetBytes(width);
                ms.WriteByte(tmp_byte1[0]);////以像素为单位说明图像的宽度
                ms.WriteByte(tmp_byte1[1]);
                ms.WriteByte(tmp_byte1[2]);
                ms.WriteByte(tmp_byte1[3]);
                //16-19 图像高度，单位像素
                byte[] tmp_byte2 = BitConverter.GetBytes(height);
                ms.WriteByte(tmp_byte2[0]);////以像素为单位说明图像的宽度
                ms.WriteByte(tmp_byte2[1]);
                ms.WriteByte(tmp_byte2[2]);
                ms.WriteByte(tmp_byte2[3]);
                //1A-1B 0001H，改值总为1
                ms.WriteByte(0x01);//0  2字节 为目标设备说明颜色平面数，总被设置为1
                ms.WriteByte(0x00);//0 
                //1C-1D 0010H=16,表示每个像素占16个比特,既改图像有2^16中颜色
                ms.WriteByte(0x10);//0  2字节 16,表示每个像素用16位表示，一共有2^16个颜色；
                ms.WriteByte(0x00);//0 
                //1E 21 BI_BITFIELDS， BI_BITFIELDS压缩
                ms.WriteByte(0x03);//0   4字节图像的压缩类型,值是0，即BI_RGB格式，不压缩
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                //22-25 图像的大小(只是图像)
                byte[] tmp_byte3 = BitConverter.GetBytes(bytePerLine * height);
                ms.WriteByte(tmp_byte3[0]);//说明位图数据的大小(图片大小不含各种信息)，当用BI_RGB格式时，可以设置为0；
                ms.WriteByte(tmp_byte3[1]);
                ms.WriteByte(tmp_byte3[2]);
                ms.WriteByte(tmp_byte3[3]);
                ////22-25 图像的大小(只是图像)
                //ms.WriteByte(0x00);//说明位图数据的大小(图片大小不含各种信息)，当用BI_RGB格式时，可以设置为0；
                //ms.WriteByte(0x00);
                //ms.WriteByte(0x00);
                //ms.WriteByte(0x00);
                //26-29 水平分辨率，缺省。
                ms.WriteByte(0x00);//0   4字节 水平分辨率，单位是像素/米，有符号整数；3780
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                //2A-2D 垂直分辨率，缺省。
                ms.WriteByte(0x00);//0   4字节 垂直分辨率，单位是像素/米，有符号整数；3780
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                //2E-31 调色板中的颜色索引数
                ms.WriteByte(0x00);//0   4字节 位图使用的调色板中的颜色索引数，为0说明使用所有；
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                //32-35 对图像显示有重要影响的颜色索引数
                ms.WriteByte(0x00);//0   4字节 对图像显示有重要影响的颜色索引数，为0说明都重要；
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0

                // RGB565格式掩码
                ms.WriteByte(0x00);//0   4字节 RGB565_MASK_RED        0xF800
                ms.WriteByte(0xF8);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0

                ms.WriteByte(0xE0);//0   4字节 RGB565_MASK_GREEN      0x07E0
                ms.WriteByte(0x07);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0

                ms.WriteByte(0x1F);//0   4字节 RGB565_MASK_BLUE       0x001F
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0
                ms.WriteByte(0x00);//0

                ms.Write(rgbFrame, 0, rgbFrame.Length);
                image = Image.FromStream(ms);

            }
            return image;
        }

        public int GetIndexOf(byte[] b, int offset, byte[] bb)
        {
            if (b == null || bb == null || b.Length == 0 || bb.Length == 0 || offset > b.Length || offset < 0) return -1;

            int i, j;

            for (i = offset; i < b.Length - 1; i++)
            {
                if (b[i] == bb[0])
                {
                    for (j = 1; j < bb.Length; j++)
                    {
                        if (b[i + j] != bb[j]) break;
                    }
                    if (j == bb.Length) return i;
                }
            }
            return -1;
        }

        private void ShowPics()
        {
            int n_read; //从 FIFO中读取的字节个数
            int index;
            byte[] tData = new byte[imageWidth * imageHeight];

            while (flag_eth == 1)
            {
                //读取的数据
                try
                {
                    do
                    {
                        byte[] rData = new byte[imageWidth + 2];
                        n_read = ab.Read(rData);

                        index = Convert.ToInt32(rData[0]) + Convert.ToInt32(rData[1] << 8);

                        Array.Copy(rData, 2, tData, index * imageWidth, imageWidth);
                    } while (index < imageHeight - 1);
                }
                catch (Exception ex)
                {
                    //MessageBox.Show(ex.ToString());
                }

                try
                {
                    im = RGB2Image(tData, imageWidth / 2, imageHeight);//imageWidth / 2  ;1280/2=640
                    FPS += 1;
                    //im = GetDataPicture(imageWidth / 2, imageHeight, tData);
                    switch (Direction)
                    {
                        case 0: im.RotateFlip(RotateFlipType.RotateNoneFlipNone); break;
                        case 1: im.RotateFlip(RotateFlipType.Rotate90FlipNone); break;
                        case 2: im.RotateFlip(RotateFlipType.Rotate180FlipNone); break;
                        case 3: im.RotateFlip(RotateFlipType.Rotate270FlipNone); break;
                        case 4: im.RotateFlip(RotateFlipType.RotateNoneFlipX); break;
                        case 5: im.RotateFlip(RotateFlipType.RotateNoneFlipY); break;
                        default: im.RotateFlip(RotateFlipType.RotateNoneFlipNone); break;
                    }
                    pictureBox1.Image = im;
                    //this.Size = new Size(pictureBox1.Image.Size.Width + 16, pictureBox1.Image.Size.Height + 85);
                    //Thread.Sleep(1);//线程睡眠100毫秒,给System.Drawing流时间弹其他窗口
                }
                catch (Exception ex)
                {
                    //MessageBox.Show(ex.ToString());
                }
            }
        }

        private void EthReceive()
        {
            while (flag_eth == 1)
            {
                try
                {
                    buffer_recv = slave_recv.Receive(ref remoteipe_recv);
                    //sockClinet.ReceiveBufferSize = 1282 * 480 * 15;
                    //sockClinet.Receive(buffer_recv);

                    ab.Write(buffer_recv);//写数据到FIFO缓冲
                }
                catch { }
            }
        }

        #region Image Rotate & Flip
        private void toolStripMenuRotate0D_Click(object sender, EventArgs e)
        {
            Direction = 0;
        }

        private void toolStripMenuRotate90D_Click(object sender, EventArgs e)
        {
            Direction = 1;
        }

        private void toolStripMenuRotate180D_Click(object sender, EventArgs e)
        {
            Direction = 2;
        }

        private void toolStripMenuRotate270D_Click(object sender, EventArgs e)
        {
            Direction = 3;
        }


        private void toolStripMenuFlipY_Click(object sender, EventArgs e)
        {
            Direction = 4;
        }

        private void toolStripMenuItemFlipX_Click(object sender, EventArgs e)
        {
            Direction = 5;
        }
        #endregion

        private void comboBoxPiexl_SelectionChangeCommitted(object sender, EventArgs e)
        {
            switch (comboBoxPiexl.SelectedIndex)
            {
                case 0: imageWidth = 1280; imageHeight = 480; break;    //640*2*480
                case 1: imageWidth = 1600; imageHeight = 480; break;    //800*2*480
                case 2: imageWidth = 1600; imageHeight = 600; break;    //800*2*600
                case 3: imageWidth = 2048; imageHeight = 768; break;    //1024*2*768
                case 4: imageWidth = 2560; imageHeight = 720; break;    //1280*2*720
                case 5: imageWidth = 3840; imageHeight = 1080; break;   //1920*2*1080
                default: imageWidth = 1280; imageHeight = 480; break;   //640*2*480
            }
        }

        private void toolStripMenuItemFullScreen_Click(object sender, EventArgs e)
        {
            //全屏预览
            if (this.FormBorderStyle != System.Windows.Forms.FormBorderStyle.None)
            {
                this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
                this.WindowState = FormWindowState.Maximized;
                pictureBox1.Dock = DockStyle.Fill;
                panel1.Visible = false;

            }
            else
            {
                this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Sizable;
                this.WindowState = FormWindowState.Normal;
                pictureBox1.Dock = DockStyle.Fill;
                panel1.Visible = true;
            }
        }

        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            string fileName = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory) + @"\" + DateTime.Now.ToString("HHmmssff") + ".bmp";
            if (fileName != "" && fileName != null)
            {
                try
                {
                    Bitmap bit = new Bitmap(pictureBox1.Image);
                    bit.Save(fileName);

                    //pictureBox1.Image.Save(fileName, System.Drawing.Imaging.ImageFormat.Bmp);
                }
                catch (Exception)
                {
                    throw;
                }
            }
        }

        private void Enable_Edit_Aera(bool bEnable)
        {
            comboBoxPiexl.Enabled = bEnable;
            textBoxRemoteIP.Enabled = bEnable;
            textBoxRemotePort.Enabled = bEnable;
            textBoxLocalIP.Enabled = bEnable;
            textBoxLocalPort.Enabled = bEnable;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.Text = "芯路恒以太网摄像头                                  FPS:" + "" + FPS.ToString();
            FPS = 0;
        }
    }
}
